#---------------------------------------------------------------------------
#
#   SuPy GUI - EnumField - Cocoa
#
#---------------------------------------------------------------------------

from AppKit import NSPopUpButton
from g_enum_field import GEnumField

class EnumField(GEnumField):

	def __init__(self, titles, values = None, **kwds):
		self.values = values
		frame = ((0, 0), (10, 10))
		ns = NSPopUpButton.alloc().initWithFrame_pullsDown_(frame, False)
		for title in titles:
			ns.addItemWithTitle_(title)
		ns.sizeToFit()
		GEnumField.__init__(self, _ns_view = ns, **kwds)

	def get_value(self):
		i = self._ns_view.indexOfSelectedItem()
		if i >= 0:
			values = self.values
			if values:
				return values[i]
			else:
				return i

	def set_value(self, value):
		values = self.values
		if values:
			try:
				i = values.index(value)
			except ValueError:
				i = -1
		else:
			if value is None:
				i = -1
			else:
				i = value
		self._ns_view.selectItemAtIndex_(i)
